#!/usr/bin/perl
# FILE: scalc.cgi
# DATE: 16/01/00
# AUTHOR: Guy Powell
# PROJECT: Dating.Com Clone
# COPYRIGHT: PerlCoders.Com
# ----
# Description: Let's face it... its the main reason we're here... to find
# our ideal partner through a complex search.

require "loadup.pl";

doparse();
if(!valcookie($in{'c'}, $in{'u'})) {
  dopage("autologout");
  exit;
}
$dbh=DBI->connect("DBI:mysql:database=TotalDate;hostname=$dbhost", $dbuser, $dbpass, {RaiseError=>1});
$sth=$dbh->prepare("SELECT UID from tbl_CSParams WHERE UID=\"$in{'u'}\"");
$sth->execute;
$result=$sth->fetchrow_hashref;
if($result->{'UID'} eq undef) {
  closedb();
  dopage("csnosettings");
  exit;
}
$sth=$dbh->prepare("DELETE from tbl_Matches WHERE for_ID=\"$in{'u'}\"");
$sth->execute;
$sth=$dbh->prepare("SELECT country,sex,sexorientation from tbl_Users WHERE UID=\"$in{'u'}\"");
$sth->execute;
$result=$sth->fetchrow_hashref;
$ucountry = $result->{'country'};
local($orientation) = $result->{'sexorientation'};
if($orientation eq undef) { $orientation = "straight"; }
if($sex eq undef) { $sex = "male"; }
if((lc($sex) eq "male") && (lc($orientation) eq "straight")) { $ssex = "female"; }
if((lc($sex) eq "male") && (lc($orientation) eq "gay")) { $ssex = "male"; }
if((lc($sex) eq "female") && (lc($orientation) eq "straight")) { $ssex = "male"; }
if((lc($sex) eq "female") && (lc($orientation) eq "gay")) { $ssex = "female"; }
$sth=$dbh->prepare("SELECT * from tbl_CSParams WHERE UID=\"$in{'u'}\"");
$sth->execute;
$result=$sth->fetchrow_hashref;
$heightimp = $result->{'HeightImp'};
$weightimp = $result->{'WeightImp'};
$intelligenceimp = $result->{'IntelligenceImp'};
$incomeimp = $result->{'IncomeImp'};
$religionimp = $result->{'ReligionImp'};
$smokeimp = $result->{'SmokeImp'};
$sheight = $result->{'Height'};
$sweight = $result->{'Weight'};
$sintelligence = $result->{'Intelligence'};
$sincome = $result->{'Income'};
$sreligion = $result->{'Religion'};
$ssmoke = $result->{'Smoke'};
$syntax = "SELECT * from tbl_Users WHERE UID <> \"$in{'u'}\"";
if($result->{'HeightImp'} eq 3) { $syntax = $syntax." AND height=\"".$result->{'Height'}."\""; }
if($result->{'WeightImp'} eq 3) { $syntax = $syntax." AND weight=\"".$result->{'Weight'}."\""; }
if($result->{'IntelligenceImp'} eq 3) { $syntax = $syntax." AND intelligence=\"".$result->{'Intelligence'}."\""; }
if($result->{'IncomeImp'} eq 3) { $syntax = $syntax." AND income=\"".$result->{'Income'}."\""; }
if($result->{'ReligionImp'} eq 3) { $syntax = $syntax." AND religion=\"".$result->{'Religion'}."\""; }
if($result->{'SmokeImp'} eq 3) { $syntax = $syntax." AND smoking=\"".$result->{'Smoke'}."\""; }
if($result->{'ReligionImp'} eq 3) { $syntax = $syntax." AND religion=\"".$result->{'Religion'}."\""; }
if($result->{'HasPic'} eq 1) { $syntax = $syntax." AND pic=\"1\""; }
if($result->{'HasVoice'} eq 1) { $syntax = $syntax." AND voice=\"1\""; }
if($result->{'SameLocale'} eq 1) { $syntax = $syntax." AND country=\"$ucountry\""; }
if($ssex ne undef) {
  $syntax = $syntax." AND sex=\"$ssex\"";
}
$syntax = $syntax." AND searchshow = \"1\"";
$sth=$dbh->prepare($syntax);
$sth->execute;
$result=$sth->fetchrow_hashref;
$dbh2=DBI->connect("DBI:mysql:database=TotalDate;hostname=$dbhost", $dbuser, $dbpass, {RaiseError=>1});
while($result->{'UID'} ne undef) {
  local($score) = 0;
  $score = $score + doscore($heightimp, $sheight, $result->{'height'});
  $score = $score + doscore($weightimp, $sweight, $result->{'weight'});
  $score = $score + doscore($intelligenceimp, $sintelligence, $result->{'intelligence'});
  $score = $score + doscore($incomeimp, $sincome, $result->{'income'});
  $score = $score + doscore($religionimp, $sreligion, $result->{'religion'});
  $score = $score + doscore($smokeimp, $ssmoke, $result->{'smoking'});
  $score = int($score/24 * 10000); $score = $score/100;
  local($age) = calcage($result->{'birthday'});
  local($ga) = $result->{'good_access'};
  $sth2=$dbh2->prepare("INSERT into tbl_Matches VALUES(\"\", \"$in{'u'}\", \"$result->{'UID'}\", \"$result->{'nick'}\", \"$result->{'state'}\", \"$result->{'country'}\", \"$result->{'sex'}\", \"$age\", \"$result->{'pic'}\", \"$score\", \"$ga\")");
  $sth2->execute;
  $result=$sth->fetchrow_hashref;
}
$dbh2->disconnect;
dopage("sdone");

closedb();

sub doscore {
  # Scores how many points are required.
  local($imp) = $_[0]; local($search) = $_[1]; local($is) = $_[2];
  if($imp eq 3) { return 4; }
  if($imp eq 2) {
    if(lc($search) eq lc($is)) { return 3; }
  }
  if($imp eq 1) {
    if(lc($search) eq lc($is)) { return 2; }
  }
  if($imp eq 0) {
    if(lc($search) eq lc($is)) { return 1; }
  }
  return 0;
}
