#!/usr/bin/perl
# FILE: optimise.cgi
# DATE: 08/01/00
# AUTHOR: Guy Powell
# PROJECT: Dating.Com Clone [Admin Section]
# COPYRIGHT: PerlCoders.Com
# ----
# Description: Runs a bit of basic optimisation.

chdir("..");
require "loadup.pl";

purgecookies();
$dbh=DBI->connect("DBI:mysql:database=TotalDate;hostname=$dbhost", $dbuser, $dbpass, {RaiseError=>1});
$sth=$dbh->prepare("OPTIMIZE TABLE tbl_BlackBook");
$sth->execute;
$sth=$dbh->prepare("OPTIMIZE TABLE tbl_Cookies");
$sth->execute;
$sth=$dbh->prepare("OPTIMIZE TABLE tbl_Left");
$sth->execute;
$sth=$dbh->prepare("OPTIMIZE TABLE tbl_Matches");
$sth->execute;
$sth=$dbh->prepare("OPTIMIZE TABLE tbl_Msgs");
$sth->execute;
$sth=$dbh->prepare("OPTIMIZE TABLE tbl_Users");
$sth->execute;
closedb();
print "Content-type: text/html\n\n";
print "Performed database optimisations.  Cleared stale cookies which haven't yet been cleaned and \"OPTIMIZE\"'d all the tables.\n";
