#!/usr/bin/perl
# FILE: audo.cgi
# DATE: 05/01/00
# AUTHOR: Guy Powell
# PROJECT: Dating.Com Clone
# COPYRIGHT: PerlCoders.Com
# ----
# Description: Actually adds the user to the database assuming that minimum
# field requirements are met.

require "loadup.pl";

doparse();
$in{'nick'}=~s/\s+//g;
$error = 0;
if($in{'password1'} ne $in{'password2'}) { $error++; $nomatch = 1; }
if($in{'password1'} eq undef) { $error++; $blankpass = 1; }
if($in{'nick'} eq undef) { $error++; $blanknick = 1; }
if($in{'bd_day'} eq undef) { $bdaymiss = 1; }
if($in{'bd_month'} eq undef) { $bdaymiss = 1; }
if($in{'bd_year'} eq undef) { $bdaymiss = 1; }
if(($in{'bd_day'} > "31") or ($in{'bd_day'} < "1")) { $bdayerr = 1; }
if(($in{'bd_month'} > "12") or ($in{'bd_month'} < "1")) { $bdayerr = 2; }
if(($in{'bd_year'} > "2020") or ($in{'bd_year'} < "1900")) { $bdayerr = 1; }
if($in{'name'} eq undef) { $error++; $blankname = 1; }
if($bdaymiss) {$error++;}
if($bdayerr) {$error++;}
if($in{'hintq'} eq undef) { $hinterr = 1; }
if($in{'hinta'} eq undef) { $hinterr = 1; }
$cpass = crypt($in{'password1'}, "gP");
$bday = $in{'bd_day'}."/".$in{'bd_month'}."/".$in{'bd_year'};
$age = calcage($bday);
if($age lt $allowage) { $error++; $tooyoung = 1; }
if(getuid($in{'nick'}) ne undef) { $error++; $ninuse = 1; }
if($error ne 0) {
  print "Content-type: text/html\n\n";
  open(html, "<$datingdir/html/adduser/errtop.html");
  while(<html>) {
    $_ =~s/\$errors/$error/g;
    print;
  }
  close(html);
  if($bdayerr) { dopage("aubdayerr"); }
  if($bdaymiss) { dopage("aubdaymiss"); }
  if($blanknick) { dopage("aublanknick"); }
  if($blankpass) { dopage("aublankpass"); }
  if($blankname) { dopage("aublankname"); }
  if($nomatch) { dopage("aupnomatch"); }
  if($ninuse) { dopage("auninuse"); }
  if($tooyoung) { dopage("autooyoung"); }
  if($hinterr) { dopage("auhinterr"); }
  dopage("auerrbottom");
  exit;
}
$dbh=DBI->connect("DBI:mysql:database=TotalDate;hostname=$dbhost", $dbuser, $dbpass, {RaiseError=>1});
local($time) = time();
$sth=$dbh->prepare("INSERT into tbl_Users VALUES(\"\", \"$in{'nick'}\",  \"$in{'name'}\", \"$in{'sex'}\", \"$in{'email'}\", \"0\", \"$cpass\",  \"$in{'city'}\", \"$in{'state'}\", \"$in{'country'}\", \"$in{'include_promotions'}\", \"$in{'info_giveout'}\", \"$in{'how_hear'}\", \"0\", \"0\", \"$bday\", \"\", \"$in{'ethnicity'}\", \"\", \"\", \"$in{'rtype'}\", \"$in{'sexorientation'}\", \"\", \"\", \"\", \"\", \"\", \"\", \"$in{'height'}\", \"$in{'weight'}\", \"\", \"\", \"\", \"\", \"\", \"$in{'mstatus'}\", \"\", \"\", \"\", \"\", \"\", \"\", \"$time\", \"0\", \"0\", \"1\", \"1\", \"1\", \"$in{'hintq'}\", \"$in{'hinta'}\")");
$sth->execute;
$sth=$dbh->prepare("SELECT * from tbl_Users WHERE nick=\"$in{'nick'}\"");
$sth->execute;
$result=$sth->fetchrow_hashref;
$newid = $result->{'UID'};
$sth=$dbh->prepare("INSERT into tbl_Msgs VALUES(\"\", \"Welcome!\", \"$welcomemsg\", \"$time\", \"new\", \"0\", \"$uid0\", \"$newid\")");
$sth->execute;
closedb();
print "Content-type: text/html\n\n";
open(html, "<$datingdir/html/adduser/ok.html");
$newu = $in{'nick'};
while(<html>) {
  $_ =~s/\$banner/$banner/g;
  $_ =~s/\$newid/$newid/g;
  $_ =~s/\$newu/$newu/g;
  print;
}
close(html);
open(sm, "|$sendmail -t") or print "Error opening sendmail for pipe<BR>\n";;
open(em, "<$datingdir/other/email_new") or print "Error opening new person email<BR>\n";
print sm "To: $in{'email'}\n";
while(<em>) { print sm; }
close(em);
close(sm);
