#!/usr/bin/perl
# FILE: bbook_mod.cgi
# DATE: 04/01/00
# AUTHOR: Guy Powell
# PROJECT: Dating.Com Clone
# COPYRIGHT: PerlCoders.Com
# ----
# Description: Modifies your black book (Address List) by either adding or
# removing someone from it.

require "loadup.pl";

doparse();
if(!valcookie($in{'c'}, $in{'u'})) {
  dopage("autologout");
  exit;
}
$sid = getuid($in{'nick'});
if($sid eq "") {
  dopage("errnouser");
  exit;
}
$dbh=DBI->connect("DBI:mysql:database=TotalDate;hostname=$dbhost", $dbuser, $dbpass, {RaiseError=>1});
$sth=$dbh->prepare("SELECT * FROM tbl_BlackBook WHERE UID=\"$in{'u'}\"");
$sth->execute;
$result=$sth->fetchrow_hashref;
# Check if already on list.
local($found) = 0;
while($result->{'UID'} ne undef) {
  if(($result->{'who_id'} eq $sid) || (lc($result->{'who_nick'}) eq lc($in{'nick'}))) {
    # Found nick and/or UID.
    $found = 1;
  }
  $result=$sth->fetchrow_hashref;
}
if(lc($in{'type'}) eq "add") {
  if($found eq 1) {
    dopage("bbalready"); $bad = 1;
  } else {
    $sth=$dbh->prepare("INSERT INTO tbl_BlackBook VALUES(\"\", \"$in{'u'}\", \"$sid\", \"$in{'nick'}\", \"$in{'comment'}\")");
    $sth->execute;
  }
} elsif(lc($in{'type'}) eq "rem") {
  if($found eq 0) {
    dopage("bbnoton"); $bad = 1;
  } else {
    $sth=$dbh->prepare("DELETE FROM tbl_BlackBook WHERE UID=\"$in{'u'}\" AND who_id=\"$sid\"");
    $sth->execute;
  }
} else {
  dopage("errbadcode"); $bad = 1;
}
if($bad ne 1) { dopage("bbmod"); }
closedb();
