#!/usr/bin/perl
# FILE: editprof.cgi
# DATE: 03/01/00
# AUTHOR: Guy Powell
# PROJECT: Dating.Com Clone
# COPYRIGHT: PerlCoders.Com
# ----
# Description: Edits your profile.

require "loadup.pl";

doparse();
if(!valcookie($in{'c'}, $in{'u'})) {
  dopage("autologout");
  exit;
}

$dbh=DBI->connect("DBI:mysql:database=TotalDate;hostname=$dbhost", $dbuser, $dbpass, {RaiseError=>1});
$sth=$dbh->prepare("SELECT * FROM tbl_Users WHERE UID=\"$in{'u'}\"");
$sth->execute;
$result=$sth->fetchrow_hashref;
closedb();
$oldkid = calcage($result->{'oldest_child'});
$youngkid = calcage($result->{'yongest_child'});

print "Content-type: text/html\n\n";
convdb();
open(prf, "<$datingdir/html/profile/edit.html");
$vlist = "user sex ethnic rtype orientation mstatus star height weight hair eyes education intelligence job income cimportance religion rimp horoscope hsclass drinking smoking drugs me idealp city state country nokids";
@vl = split/ /, $vlist;
while(<prf>) {
  foreach $tmp (@vl) {
    if($convtmp{$tmp} ne undef) {
      $tmp2 = $convtmp{$tmp};
    } else {
      $tmp2 = $tmp;
    }
    $_ =~s/\$$tmp/$result->{$tmp2}/g;
  }
  if(!ispriv($in{'u'})) {
    $_ =~s/\$banner/$banner/g;
  } else {
    $_ =~s/\$banner//g;
  }
  $_ =~s/\$youngkid/$youngkid/g;
  $_ =~s/\$oldkid/$oldkid/g;
  $_ =~s/\$uid/$in{'u'}/g;
  $_ =~s/\$cookie/$in{'c'}/g;
  print;
}
close(prf);

sub convdb {
  # Set up a quick, temporary conversion.
  # $convtmp{<dynamic html name>} = MySQL field in tbl_Users
  $convtmp{"sex"} = "sex";
  $convtmp{"ethnic"} = "ethnicity";
  $convtmp{"orientation"} = "sexorientation";
  $convtmp{"education"} = "edlevel";
  $convtmp{"cimportance"} = "c_imp";
  $convtmp{"hsclass"} = "hs_class";
  $convtmp{"nokids"} = "no_children";
  $convtmp{"me"} = "self_description";
  $convtmp{"idealp"} = "ideal_partner";
}
