#!/usr/bin/perl
# FILE: listmag.cgi
# DATE: 11/01/00
# AUTHOR: Guy Powell
# PROJECT: Dating.Com Clone
# COPYRIGHT: PerlCoders.Com
# ----
# Description: Lists all articles in said magazine topic unless topic is
# null in which case we list all topics.

require "loadup.pl";

doparse();
if(!valcookie($in{'c'}, $in{'u'})) {
  dopage("autologout");
  exit;
}
if($in{'topic'} ne undef) {
  dopage("topictop");
  $dbh=DBI->connect("DBI:mysql:database=TotalDate;hostname=$dbhost", $dbuser, $dbpass, {RaiseError=>1});
  $sth=$dbh->prepare("SELECT Topic from tbl_MagTopics WHERE TopicID=\"$in{'topic'}\"");
  $sth->execute;
  $result=$sth->fetchrow_hashref;
  local($topic) = $result->{'Topic'};
  $sth=$dbh->prepare("SELECT * from tbl_MagArticles WHERE TopicID = \"$in{'topic'}\" AND State=\"v\"");
  $sth->execute;
  $result=$sth->fetchrow_hashref;
  open(html, "<$datingdir/html/magazine/topicmiddle.html"); undef($/); $line = <html>; $/ = "\n"; close(html);
  while($result->{'ArticleID'} ne undef) {
    local($aid) = $result->{'ArticleID'};
    local($li) = $line;
    $li =~s/\$subject/$result->{'Subject'}/g;
    if(!ispriv($in{'u'})) {
      $li =~s/\$banner/$banner/g;
    } else {
      $li =~s/\$banner//g;
    }
    $li =~s/\$by_nick/$result->{'By_Nick'}/g;
    $li =~s/\$by_id/$result->{'By_ID'}/g;
    $li =~s/\$topic/$topic/g;
    $li =~s/\$user/$in{'u'}/g;
    $li =~s/\$cookie/$in{'c'}/g;
    $li =~s/\$link/listart.cgi?article=$aid&c=$in{'c'}&u=$in{'u'}/g;
    print $li;
    $result=$sth->fetchrow_hashref;
  }
  dopage("topicbottom");
} else {
  dopage("magtop");
  $dbh=DBI->connect("DBI:mysql:database=TotalDate;hostname=$dbhost", $dbuser, $dbpass, {RaiseError=>1});
  $sth=$dbh->prepare("SELECT * from tbl_MagTopics");
  $sth->execute;
  $result=$sth->fetchrow_hashref;
  open(html, "<$datingdir/html/magazine/magmiddle.html"); undef($/); $line = <html>; $/ = "\n"; close(html);
  while($result->{'TopicID'} ne undef) {
    local($aid) = $result->{'ArticleID'};
    local($li) = $line;
    $li =~s/\$description/$result->{'Description'}/g;
    $li =~s/\$topic/$result->{'Topic'}/g;
    $li =~s/\$user/$in{'u'}/g;
    $li =~s/\$cookie/$in{'c'}/g;
    $li =~s/\$link/listmag.cgi?topic=$result->{'TopicID'}&u=$in{'u'}&c=$in{'c'}/g;
    print $li;
    $result=$sth->fetchrow_hashref;
  }
  dopage("magbottom");
}
closedb();
