#!/usr/bin/perl
# FILE: recent.cgi
# DATE: 14/01/00
# AUTHOR: Guy Powell
# PROJECT: Dating.Com Clone
# COPYRIGHT: PerlCoders.Com
# ----
# Description: If you've paid, it lists all the users who signed up since
# your last logon.

require "loadup.pl";

doparse();
if(!valcookie($in{'c'}, $in{'u'})) {
  dopage("autologout");
  exit;
}
if(!ispriv($in{'u'})) {
  dopage("notpriv");
  exit;
}
dopage("recenttop");
$dbh=DBI->connect("DBI:mysql:database=TotalDate;hostname=$dbhost", $dbuser, $dbpass, {RaiseError=>1});
$sth=$dbh->prepare("SELECT llog_but1 from tbl_Users WHERE UID=\"$in{'u'}\"");
$sth->execute;
$result=$sth->fetchrow_hashref;
$llog = $result->{'llog_but1'};
$sth=$dbh->prepare("SELECT UID,nick,birthday,country from tbl_Users WHERE createUTC > \"$llog\"");
$sth->execute;
$result=$sth->fetchrow_hashref;
open(html, "<$datingdir/html/recent/middle.html"); undef($/); $line = <html>; $/ = "\n"; close(html);
$un = getuser($in{'u'});
while($result->{'UID'} ne undef) {
  local($tmp) = $line;
  $tmp =~s/\$un/$un/g;
  $tmp =~s/\$user/$in{'u'}/g;
  $tmp =~s/\$cookie/$in{'c'}/g;
  $fage = calcage($result->{'birthday'});
  $tmp =~s/\$fid/$result->{'UID'}/g;
  $tmp =~s/\$fage/$fage/g;
  $tmp =~s/\$fnick/$result->{'nick'}/g;
  $tmp =~s/\$fcountry/$result->{'country'}/g;
  print $tmp;
  $result=$sth->fetchrow_hashref;
}
closedb();
dopage("recentbottom");
