#!/usr/bin/perl
# FILE: top10.cgi
# DATE: 16/01/00
# AUTHOR: Guy Powell
# PROJECT: Dating.Com Clone
# COPYRIGHT: PerlCoders.Com
# ----
# Description: Lists

require "loadup.pl";

doparse();
if(!valcookie($in{'c'}, $in{'u'})) {
  dopage("autologout");
  exit;
}
$dbh=DBI->connect("DBI:mysql:database=TotalDate;hostname=$dbhost", $dbuser, $dbpass, {RaiseError=>1});
$sth=$dbh->prepare("DELETE from tbl_Top10");
$sth->execute;
$sth=$dbh->prepare("SELECT ranktotal, rankscore, birthday, country, sex, nick, UID from tbl_Users WHERE ranktotal <> \"\" AND ranktotal > \"0\"");
$sth->execute;
$result=$sth->fetchrow_hashref;
$dbh2=DBI->connect("DBI:mysql:database=TotalDate;hostname=$dbhost", $dbuser, $dbpass, {RaiseError=>1});
dopage("top10top");
while($result->{'UID'} ne undef) {
  local($uid) = $result->{'UID'};
  local($percent) = $result->{'rankscore'} / $result->{'ranktotal'};
  $percent = $percent / 10;
  $percent = int($percent * 10000);
  $percent = $percent / 100;
  local($age) = calcage($result->{'birthday'});
  $sth2=$dbh2->prepare("INSERT into tbl_Top10 VALUES(\"$uid\", \"$percent\", \"$result->{'nick'}\", \"$age\", \"$result->{'sex'}\", \"$result->{'country'}\")");
  $sth2->execute;
  $result=$sth->fetchrow_hashref;
}
$dbh2->disconnect;
$sth=$dbh->prepare("SELECT * from tbl_Top10 ORDER BY Percent DESC LIMIT 10");
$sth->execute;
$result=$sth->fetchrow_hashref;
open(html, "<$datingdir/html/top10/middle.html"); undef($/); $line = <html>; $/ = "\n"; close(html);
while($result->{'UID'} ne undef) {
  local($tmpln) = $line;
  $tmpln =~s/\$fuid/$result->{'UID'}/g;
  $tmpln =~s/\$fnick/$result->{'Nick'}/g;
  $tmpln =~s/\$fage/$result->{'Age'}/g;
  $tmpln =~s/\$fpercent/$result->{'Percent'}/g;
  $tmpln =~s/\$fsex/$result->{'Sex'}/g;
  $tmpln =~s/\$fcountry/$result->{'Country'}/g;
  $tmpln =~s/\$user/$in{'u'}/g;
  $tmpln =~s/\$cookie/$in{'c'}/g;
  print $tmpln;
  $result=$sth->fetchrow_hashref;
}
dopage("top10bottom");
closedb();
