#!/usr/bin/perl
# FILE: viewpoll.cgi
# DATE: 08/01/00
# AUTHOR: Guy Powell
# PROJECT: Dating.Com Clone
# COPYRIGHT: PerlCoders.Com
# ----
# Description: Views poll results.

require "loadup.pl";

doparse();
if(!valcookie($in{'c'}, $in{'u'})) {
  dopage("autologout");
  exit;
}
print "Content-type: text/html\n\n";
$dbh=DBI->connect("DBI:mysql:database=TotalDate;hostname=$dbhost", $dbuser, $dbpass, {RaiseError=>1});
$sth=$dbh->prepare("SELECT * from tbl_PollQ where PollID=\"$in{'id'}\"");
$sth->execute;
$result=$sth->fetchrow_hashref;
$a1 = $result->{'A1'};
$a2 = $result->{'A2'};
$a3 = $result->{'A3'};
$q = $result->{'Question'};
$sth=$dbh->prepare("SELECT * from tbl_PollA where PollID=\"$in{'id'}\"");
$sth->execute;
$result=$sth->fetchrow_hashref;
$total = $result->{'NoA1'} + $result->{'NoA2'} + $result->{'NoA3'};
if($total eq 0) { $total = 1; }
$p1 = int(($result->{'NoA1'} / $total) * 1000)/10;
$p2 = int(($result->{'NoA2'} / $total) * 1000)/10;
$p3 = int(($result->{'NoA3'} / $total) * 1000)/10;
closedb();
open(html, "<$datingdir/html/poll/view.html");
while(<html>) {
  if(!ispriv($in{'u'})) {
    $_ =~s/\$banner/$banner/g;
  } else {
    $_ =~s/\$banner//g;
  }
  $_ =~s/\$q/$q/g;
  $_ =~s/\$a1/$a1/g;
  $_ =~s/\$a2/$a2/g;
  $_ =~s/\$a3/$a3/g;
  $_ =~s/\$p1/$p1/g;
  $_ =~s/\$p2/$p2/g;
  $_ =~s/\$p3/$p3/g;
  $_ =~s/\$user/$in{'u'}/g;
  $_ =~s/\$cookie/$in{'c'}/g;
  print;
}
close(html);
