#!/usr/bin/perl
# FILE: viewprofile.cgi
# DATE: 02/01/00
# AUTHOR: Guy Powell
# PROJECT: Dating.Com Clone
# COPYRIGHT: PerlCoders.Com
# ----
# Description: Views "who"'s profile.  Returns a sensible order.

require "loadup.pl";

doparse();
if(!valcookie($in{'c'}, $in{'u'})) {
  dopage("autologout");
  exit;
}

if($in{'who'} eq undef) { $in{'who'} = $in{'u'}; }
$dbh=DBI->connect("DBI:mysql:database=TotalDate;hostname=$dbhost", $dbuser, $dbpass, {RaiseError=>1});
$sth=$dbh->prepare("SELECT * FROM tbl_Users WHERE UID=\"$in{'who'}\"");
$sth->execute;
$result=$sth->fetchrow_hashref;
closedb();
$age = calcage($result->{'birthday'});

print "Content-type: text/html\n\n";
convdb();
open(prf, "<$datingdir/html/viewprofile/viewprofile.html");
$vlist = "user sex ethnic rtype orientation mstatus star height weight hair eyes education intelligence job income cimportance religion rimp horoscope hsclass drinking smoking drugs nick me idealp city state country";
@vl = split/ /, $vlist;
while(<prf>) {
  foreach $tmp (@vl) {
    if($convtmp{$tmp} ne undef) {
      $tmp2 = $convtmp{$tmp};
    } else {
      $tmp2 = $tmp;
    }
    if($result->{$tmp2} ne undef) {
      $_ =~s/\$$tmp/$result->{$tmp2}/g;
    } else {
      $_ =~s/\$$tmp/$nonspec/g;
    }
  }
  if(!ispriv($in{'u'})) {
    $_ =~s/\$banner/$banner/g;
  } else {
    $_ =~s/\$banner//g;
  }
  $_ =~s/\$cookie/$in{'c'}/g;
  $_ =~s/\$ourid/$in{'u'}/g;
  $_ =~s/\$age/$age/g;
  if(($result->{'ranktotal'} ne 0) && ($result->{'ranktotal'} ne undef)) {
    $rval = ($result->{'rankscore'} / $result->{'ranktotal'})/10;
    $rval = int($rval * 10000); $rval = $rval/100;
  } else {
    $rval = 0;
  }
  $_ =~s/\$urank/$rval/g;
  $_ =~s/\$voiceget/voget.cgi?u=$in{'u'}&c=$in{'c'}&who=$in{'who'}/g;
  $_ =~s/\$voice/vopic.cgi?u=$in{'u'}&c=$in{'c'}&who=$in{'who'}/g;
  $_ =~s/\$pic/viewpic.cgi?u=$in{'u'}&c=$in{'c'}&who=$in{'who'}/g;
  print;
}
close(prf);

sub convdb {
  # Set up a quick, temporary conversion.
  $convtmp{"user"} = "UID";
  $convtmp{"sex"} = "sex";
  $convtmp{"ethnic"} = "ethnicity";
  $convtmp{"orientation"} = "sexorientation";
  $convtmp{"education"} = "edlevel";
  $convtmp{"cimportance"} = "c_imp";
  $convtmp{"hsclass"} = "hs_class";
  $convtmp{"me"} = "self_description";
  $convtmp{"idealp"} = "ideal_partner";
}
